
import "./assets/font/iconfont.less";
import { setGlobalVariable, http } from 'codingtalk-core'

export * from './components';
export * from "./utils";
export * from 'codingtalk-core'

const defaultConfig = {
  transformer: {
    app: ({ status, data }) => status ? data : {},
    entity: ({ status, data }, key, params) => status ? (['form', 'detail'].includes(key) ? data[key][params?.action] : data[key]) : {}
  }
}

export const install = async (app, options = {
  libs: {},
  entities: {},
  cache: {},
  hook: {},
  remote: {
    oss: {},
    app: {},
    entity: {}
  }
}) => {
  const { libs, entities, cache, hook, remote } = options
  setGlobalVariable(null, {
    app: {
      ...await http.request({
        baseURL: typeof remote?.app === 'string' ? remote?.app : remote?.app.url,
        url: '',
        method: "post",
        data: {},
        headers: { "Content-Type": "application/json" },
      })
    },
    libs,
    entities,
    cache,
    hook,
    remote: {
      ...remote,
      ...{
        entity: {
          ... typeof remote.entity === 'string' ? {
            url: remote.entity
          } : remote.entity,
          transformer: remote.entity.transformer || defaultConfig.transformer.entity
        }
      }
    },
  })
};
