import { getGlobalVariable, uuid } from 'codingtalk-core';

export const uploadFile = (tempFilePath, tempFile) => {
  const { url: ossUrl} = typeof getGlobalVariable('remote')?.oss === 'string' ? { url: getGlobalVariable('remote')?.oss } : getGlobalVariable('remote')?.oss;
  return new Promise((resolve) => {
    uni.request({
      url: ossUrl,
      data: {
        insertDb: 0,
        dir: ''
      },
      header: {
        'Content-Type': 'application/json',
      },
      method: "POST",
      success: (res) => {
        const { status, data } = res.data;
        if (status) {
          const { accessKey, host, policy, signature, callback } = data;
          uni.uploadFile({
            url: 'https://' + host,
            filePath: tempFile.path,
            name: 'file',
            formData: {
              'name': tempFile.name,
              'key': uuid(),
              'policy': policy,
              'OSSAccessKeyId': accessKey,
              'signature': signature,
              'success_action_status': '200',
              callback
            },
            success: (uploadFileRes) => {
              const objOssRes = JSON.parse(uploadFileRes.data);
              if (objOssRes.status) {
                const { filename, url } = objOssRes.data;
                resolve({
                  previewUrl: tempFilePath,
                  file: tempFile,
                  oss: { filename, url }
                });
              }
            },
            fail: (e) => {
              console.log("======> upload oss failed:" + e);
            }
          });
        }
      }
    });
  });
}